﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System;
using System.Collections.ObjectModel;
using System.Collections.Specialized;
using System.ComponentModel;
using System.Globalization;
using System.IO.Packaging;
using System.Windows;
using System.Windows.Controls.Primitives;
using System.Windows.Input;
using System.Windows.Controls.Primitives;
using System.Windows.Controls;

namespace HierXamDataGrid
{
    public class ViewModel
    {

        public ObservableCollection<AccntModel> Accounts { get; set; }
        public ICommand AddAlexOrderCommand { get; set; }
        public ICommand AddAnitaOrderCommand { get; set; }

        public ViewModel()
        {
            TestData();
            AddAlexOrderCommand = new RelayCommand(ExecuteAlexOrderCommand, CanExecuteAddOrderCommand);
            AddAnitaOrderCommand = new RelayCommand(ExecuteAnitaOrderCommand, CanExecuteAddOrderCommand);
        }

        public bool CanExecuteAddOrderCommand(object parameter)
        {
            return true;
        }

        public void ExecuteAlexOrderCommand(object parameter)
        {
            AddOrder("Alex");
        }

        public void ExecuteAnitaOrderCommand(object parameter)
        {
            AddOrder("Anita");
        }

        private void AddOrder(string account)
        {
            AccntModel act = null;
            foreach (var accntModel in Accounts)
            {
                if (accntModel.Account == account)
                {
                    act = accntModel;
                    break;
                }
            }

            if (act == null) return;
            var ord = new OrderModel {Account = account == "Alex" ? "" : account, Sym = "NewSym", OrderTime = DateTime.Now, Price = 21.2, Side = "SS" };
            act.Orders.Add(ord);
        }

        private void TestData()
        {
            Accounts = new ObservableCollection<AccntModel>
            {
                new AccntModel
                {
                    Account = "Zip", 
                    Orders = new ObservableCollection<OrderModel>
                    {
                    }
                },
                new AccntModel
                {
                    Account = "Acnt1", 
                    Orders = new ObservableCollection<OrderModel>
                    {
                        new OrderModel {Account ="Acnt1",  Sym = "IBM", OrderTime = new DateTime(2014, 12, 1), Price = 101.9, Side = "S"},
                        new OrderModel {Account ="Acnt1", Sym = "AOL", OrderTime = new DateTime(2014, 03, 22), Price = 31.1, Side = "B"},
                        new OrderModel {Account ="Acnt1", Sym = "MSFT", OrderTime = new DateTime(2014, 09, 24), Price = 46.3, Side = "B"},
                    }
                },

                new AccntModel
                {
                    Account = "Alex", 
                    Orders = new ObservableCollection<OrderModel>
                    {
                        new OrderModel {Sym = "IBM", OrderTime = new DateTime(2014, 12, 1), Price = 101.9, Side = "S"},
                        new OrderModel {Sym = "AOL", OrderTime = new DateTime(2014, 03, 22), Price = 31.1, Side = "B"},
                        new OrderModel {Sym = "MSFT", OrderTime = new DateTime(2014, 09, 24), Price = 46.3, Side = "B"},
                        new OrderModel {Sym = "MSFT", OrderTime = new DateTime(2014, 09, 24), Price = 46.3, Side = "B"},
                    }
                },

                new AccntModel
                {
                    Account = "Anita", 
                    Orders = new ObservableCollection<OrderModel>
                    {
                        new OrderModel {Account = "Anita", Sym = "IBM", OrderTime = new DateTime(2014, 12, 1), Price = 101.9, Side = "S"},
                        new OrderModel {Account = "Anita", Sym = "AOL", OrderTime = new DateTime(2014, 03, 22), Price = 31.1, Side = "B"},
                        new OrderModel {Account = "Anita", Sym = "MSFT", OrderTime = new DateTime(2014, 09, 24), Price = 46.3, Side = "B"},
                        new OrderModel {Account = "Anita", Sym = "MSFT", OrderTime = new DateTime(2014, 09, 24), Price = 46.3, Side = "B"},
                        new OrderModel {Account = "Anita", Sym = "MSFT", OrderTime = new DateTime(2014, 09, 24), Price = 46.3, Side = "B"},
                    }
                },

            };
        }
   }

    public class RelayCommand : ICommand
    {
        private Action<object> execute;

        private Predicate<object> canExecute;

        private event EventHandler CanExecuteChangedInternal;

        public RelayCommand(Action<object> execute)
            : this(execute, DefaultCanExecute)
        {
        }

        public RelayCommand(Action<object> execute, Predicate<object> canExecute)
        {
            if (execute == null)
            {
                throw new ArgumentNullException("execute");
            }

            if (canExecute == null)
            {
                throw new ArgumentNullException("canExecute");
            }

            this.execute = execute;
            this.canExecute = canExecute;
        }

        public event EventHandler CanExecuteChanged
        {
            add
            {
                CommandManager.RequerySuggested += value;
                this.CanExecuteChangedInternal += value;
            }

            remove
            {
                CommandManager.RequerySuggested -= value;
                this.CanExecuteChangedInternal -= value;
            }
        }

        public bool CanExecute(object parameter)
        {
            return this.canExecute != null && this.canExecute(parameter);
        }

        public void Execute(object parameter)
        {
            this.execute(parameter);
        }

        public void OnCanExecuteChanged()
        {
            EventHandler handler = this.CanExecuteChangedInternal;
            if (handler != null)
            {
                //DispatcherHelper.BeginInvokeOnUIThread(() => handler.Invoke(this, EventArgs.Empty));
                handler.Invoke(this, EventArgs.Empty);
            }
        }

        public void Destroy()
        {
            this.canExecute = _ => false;
            this.execute = _ => { return; };
        }

        private static bool DefaultCanExecute(object parameter)
        {
            return true;
        }
    }
}
